unit Prtdemo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Printsel, ExtCtrls, Printers, prtSetup, Buttons;

type
  TFormPrinterDialog = class(TForm)
    Panel4: TPanel;
    Memo1: TMemo;
    Panel5: TPanel;
    btnSetupPrinter1: TBitBtn;
    btnSetupPrinter2: TBitBtn;
    btnPrintThisForm1: TBitBtn;
    btnPrint2testPages: TBitBtn;
    btnPrintThisForm2: TBitBtn;
    Label4: TLabel;
    Edit1: TEdit;
    lblPrinter1: TLabel;
    lblPrinter2: TLabel;
    Panel1: TPanel;
    Image1: TImage;
    procedure btnSetupPrinter1Click(Sender: TObject);
    procedure btnSetupPrinter2Click(Sender: TObject);
    procedure btnPrintThisForm1Click(Sender: TObject);
    procedure btnPrint2testPagesClick(Sender: TObject);
    procedure btnPrintThisForm2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure CheckButtons;
  end;

var
  FormPrinterDialog: TFormPrinterDialog;

implementation

{$R *.DFM}

const prt1 = 'DemoPrinter1';
      prt2 = 'DemoPrinter2';

procedure TFormPrinterDialog.btnSetupPrinter1Click(Sender: TObject);
begin
  SetupPrinter(prt1);
  lblPrinter1.Caption:=Printer.Printers[Printer.PrinterIndex];
  CheckButtons;
end;

procedure TFormPrinterDialog.btnSetupPrinter2Click(Sender: TObject);
begin
  SetupPrinter(prt2);
  lblPrinter2.Caption:=Printer.Printers[Printer.PrinterIndex];
  CheckButtons;
end;

procedure TFormPrinterDialog.btnPrintThisForm1Click(Sender: TObject);
begin
  SelectPrinterConfiguration(prt1);
  Print;
end;

procedure TFormPrinterDialog.btnPrintThisForm2Click(Sender: TObject);
begin
  SelectPrinterConfiguration(prt2);
  Print;
end;

procedure TFormPrinterDialog.btnPrint2testPagesClick(Sender: TObject);
begin
  SelectPrinterConfiguration(prt1);
  Printer.BeginDoc;
  Printer.Canvas.MoveTo(10,120);
  Printer.Canvas.LineTo(2000,120);
  Printer.Canvas.TextOut(100,100,'page 1');
  SelectPrinterConfiguration(prt2);
  dlgPrinterSetup.prtDef.NewPage;
  Printer.Canvas.TextOut(100,100,'page 2');
  Printer.Canvas.MoveTo(10,120);
  Printer.Canvas.LineTo(2000,120);
  Printer.EndDoc;
  SelectPrinterConfiguration(prt1);
end;

procedure TFormPrinterDialog.FormShow(Sender: TObject);
begin
  SelectPrinterConfiguration(prt2);
  lblPrinter2.Caption:=Printer.Printers[Printer.PrinterIndex];
  SelectPrinterConfiguration(prt1);
  lblPrinter1.Caption:=Printer.Printers[Printer.PrinterIndex];
  CheckButtons;
end;

procedure TFormPrinterDialog.CheckButtons;
begin
  btnPrint2testPages.Enabled:=lblPrinter1.Caption=lblPrinter2.Caption;
end;
end.
